-module(akhamoth).

-export([compile/1]).

-spec compile(Path :: file:name_all()) -> any().
compile(Path) ->
    {ok, SrcBin} = file:read_file(Path),
    Src = unicode:characters_to_list(SrcBin),
    Lexer = akh_lexer:new(Src),
    collect(Lexer, []).

collect(Lexer, Acc) ->
    case akh_lexer:next(Lexer) of
        none -> Acc;
        {ok, T, L} -> collect(L, [T | Acc])
    end.
